#include "Drv_PWM.h"

// Configure the period for each timer
//EPWM1A is A-INV UP Drv      EPWM1B is A-INV DOWN Drv
#define EPWM1_TIMER_TBPRD  1500  	// Period register	20k
#define EPWM1_MAX_CMPA     1490		//98%
#define EPWM1_MIN_CMPA       1
#define EPWM1_MAX_CMPB     1490
#define EPWM1_MIN_CMPB       1
#define EPWM1_DBRED    114		//180			//1.5us
#define EPWM1_DBFED    114		//180

//EPWM2A is A-INV AuxUP Drv      EPWM2B is A-INV AuxDOWN Drv
#define EPWM2_TIMER_TBPRD  1500  // Period register
#define EPWM2_MAX_CMPA     1490
#define EPWM2_MIN_CMPA       1
#define EPWM2_MAX_CMPB     1490
#define EPWM2_MIN_CMPB       1
#define EPWM2_DBRED    60		//180
#define EPWM2_DBFED    60		//180

//EPWM3A is FAN Drv
#define EPWM3_TIMER_TBPRD  30000  // Period register
#define EPWM3_MAX_CMPA     2940
#define EPWM3_MIN_CMPA       1
#define EPWM3_MAX_CMPB     2940
#define EPWM3_MIN_CMPB       1

//EPWM4A is B-INV UP Drv      EPWM4B is B-INV DOWN Drv
#define EPWM4_TIMER_TBPRD  1500  // Period register
#define EPWM4_MAX_CMPA     1490
#define EPWM4_MIN_CMPA       1
#define EPWM4_MAX_CMPB     1490
#define EPWM4_MIN_CMPB  	 1
#define EPWM4_DBRED    114		//180
#define EPWM4_DBFED    114		//180

//EPWM5A is A-INV AuxUP Drv      EPWM5B is A-INV AuxDOWN Drv	20k
#define EPWM5_TIMER_TBPRD  1500
#define EPWM5_MAX_CMPA     1490
#define EPWM5_MIN_CMPA       1
#define EPWM5_MAX_CMPB     1490
#define EPWM5_MIN_CMPB       1
#define EPWM5_DBRED    60		//180
#define EPWM5_DBFED    60		//180

//EPWM6 Interrupt	40k
#define EPWM6_TIMER_TBPRD  1500
#define EPWM6_MIN_CMPA       1
#define EPWM6_MIN_CMPB       1


//EPWM7A is C-INV UP Drv      EPWM7B is C-INV DOWN Drv
#define EPWM7_TIMER_TBPRD  1500
#define EPWM7_MAX_CMPA     1490
#define EPWM7_MIN_CMPA       1
#define EPWM7_MAX_CMPB     1490
#define EPWM7_MIN_CMPB       1
#define EPWM7_DBRED    114		//180
#define EPWM7_DBFED    114		//180

//EPWM8A is C-INV AuxUP Drv   EPWM8B is C-INV AuxDOWN Drv
#define EPWM8_TIMER_TBPRD  1500
#define EPWM8_MAX_CMPA     1490
#define EPWM8_MIN_CMPA       1
#define EPWM8_MAX_CMPB     1490
#define EPWM8_MIN_CMPB       1
#define EPWM8_DBRED    60		//180
#define EPWM8_DBFED    60		//180

//EPWM9A is LBS
#define EPWM9_TIMER_TBPRD  3000
#define EPWM9_MAX_CMPA     2940
#define EPWM9_MIN_CMPA       1
#define EPWM9_MAX_CMPB     2940
#define EPWM9_MIN_CMPB       1
#define EPWM9_DBRED   180
#define EPWM9_DBFED   180

//EPWM10A is Carrier Sync
#define EPWM10_TIMER_TBPRD  3000
#define EPWM10_MAX_CMPA	   2940
#define EPWM10_MIN_CMPA       1260
#define EPWM10_MAX_CMPB       2940
#define EPWM10_MIN_CMPB       1
#define EPWM10_DBRED   180
#define EPWM10_DBFED   180

//EPWM11A is Low Freq Sync
#define EPWM11_TIMER_TBPRD  18000
#define EPWM11_MAX_CMPA     2940
#define EPWM11_MIN_CMPA       1
#define EPWM11_MAX_CMPB     2940
#define EPWM11_MIN_CMPB       1
#define EPWM11_DBRED   0					//180
#define EPWM11_DBFED   0					//180

//EPWM12 is communication ISR
#define EPWM12_TIMER_TBPRD  3000
#define EPWM12_MAX_CMPA     2940
#define EPWM12_MIN_CMPA       1
#define EPWM12_MAX_CMPB     2940
#define EPWM12_MIN_CMPB       1
#define EPWM12_DBRED   180
#define EPWM12_DBFED   180

// To keep track of which way the compare value is moving
#define EPWM_CMP_UP   1
#define EPWM_CMP_DOWN 0
#define	AQC_NO_ACTION	0x0
#define	FORCE_LOW		0x1
#define	FORCE_HIGH		0x2
//ʼEPWM drv
//EPwm1,EPwm2,EPwm4,EPwm5,EPwm7,EPwm8, for INV
//EPwm3, for Fan drv
//EPwm4,for 
//EPwm5 for chg drv
//EPwm6 for rec drv or DCDC positive drv
//EPwm7 LLC drv

 void	Class_PWMDrv::Drv_PWMInit(void)										
{

/*******************************************************************************/

	 //EPWM1A is A-INV UP Drv      EPWM1B is A-INV DOWN Drv

/******************************************************************************/
	EALLOW;
	CpuSysRegs.PCLKCR0.bit.TBCLKSYNC =0;
	EPwm1Regs.TZFRC.bit.OST = TZ_ENABLE;
	ClkCfgRegs.PERCLKDIVSEL.bit.EPWMCLKDIV = 1;

	// Setup TBCLK
	EPwm1Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; // Count up-down
	EPwm1Regs.TBPRD = EPWM1_TIMER_TBPRD;       // Set timer period
//	EPwm1Regs.TBCTL.bit.PHSEN = TB_DISABLE;
	EPwm1Regs.TBPHS.bit.TBPHS = 0x0001;       // Phase is 0
	EPwm1Regs.TBCTR = 0x0000;                  // Clear counter
	EPwm1Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   // Clock ratio to SYSCLKOUT
	EPwm1Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm1Regs.TBCTL.bit.PHSDIR = TB_UP;
//	EPwm1Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO;
	EPwm1Regs.TBCTL.bit.PRDLD = TB_SHADOW;
	#if PARALLEL
	EPwm1Regs.TBCTL.bit.PHSEN = TB_DISABLE;    // enable phase loading
	EPwm1Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_IN;
	#else
	EPwm1Regs.TBCTL.bit.PHSEN = TB_DISABLE;
	EPwm1Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO;
	#endif
	
	// Setup shadow register load on ZERO
	EPwm1Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;
	EPwm1Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
	EPwm1Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;
	EPwm1Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO_PRD;

	// Set Compare values
	EPwm1Regs.CMPA.bit.CMPA = EPWM1_MIN_CMPA;    // Set compare A value
	EPwm1Regs.CMPB.bit.CMPB = EPWM1_MIN_CMPB;              // Set Compare B value

	// Set actions
	EPwm1Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
	EPwm1Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
	EPwm1Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
	EPwm1Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
	EPwm1Regs.AQCTLA.bit.PRD = AQ_NO_ACTION;
	EPwm1Regs.AQCTLA.bit.ZRO = AQ_NO_ACTION;

	EPwm1Regs.AQCTLB.bit.CAU = AQ_NO_ACTION;        			//CNT = CMPA up   ->0
	EPwm1Regs.AQCTLB.bit.CAD = AQ_NO_ACTION;        				//CNT = CMPA down ->1
	EPwm1Regs.AQCTLB.bit.CBU = AQ_CLEAR;
	EPwm1Regs.AQCTLB.bit.CBD = AQ_SET;
	EPwm1Regs.AQCTLB.bit.PRD = AQ_NO_ACTION;
	EPwm1Regs.AQCTLB.bit.ZRO = AQ_NO_ACTION;

	EPwm1Regs.AQSFRC.bit.RLDCSF = 3;		        		//The active register load immediately
	EPwm1Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm1Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH

	EPwm1Regs.DBCTL.bit.IN_MODE = DBA_RED_DBB_FED;				//EPWMxA In is the source for rising-edge delayed signal.
														//EPWMxA In is the source for falling-edge delayed signal.
	EPwm1Regs.DBCTL.bit.DEDB_MODE = 0;
	EPwm1Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC;				//Active high complementary (AHC). EPWMxB is inverted.
	EPwm1Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE;			//Enable dead band time configuration
	EPwm1Regs.DBCTL.bit.OUTSWAP = 0;						//A pathͬʱΪEPWMABʱ
	EPwm1Regs.DBRED = EPWM1_DBRED;								//SYSCLK/EPWM2_DB = 60M/0.7M
	EPwm1Regs.DBFED = EPWM1_DBFED;								//SYSCLK/EPWM2_DB = 60M/0.7M

	EPwm1Regs.PCCTL.bit.CHPEN = CHP_DISABLE;						//Disable chopping function

	EPwm1Regs.TZSEL.bit.DCAEVT2 = TZ_ENABLE;		//Enable DCAEVT2 as a CBC trip source for EPWM1
	EPwm1Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;		//DCAH==High,trigger TZ
	EPwm1Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm1Regs.TZCTL.bit.TZB = TZ_FORCE_LO;
	EPwm1Regs.TZCLR.bit.CBCPULSE = 1;				//CTR = Zero or PRD pulse clears CBC trip latch

	EPwm1Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN4;
	EPwm1Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
	EPwm1Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
	EPwm1Regs.DCAHTRIPSEL.bit.TRIPINPUT4 = 1;

	EPwm1Regs.ETSEL.bit.SOCAEN = 1;						//Enable SOCA to start ADC
	EPwm1Regs.ETSEL.bit.SOCASEL = ET_CTR_PRDZERO;		//ADC starts while CNT=ET_CTR_ZERO//Enable event time-base counter equal to period (TBCTR = TBPRD)
	EPwm1Regs.ETPS.bit.SOCAPRD = ET_1ST;				//ADC starts every 1 event

	EPwmXbarRegs.TRIP4MUX0TO15CFG.bit.MUX4 = 1;			//CMP3P HIGH or Low
	EPwmXbarRegs.TRIP4MUXENABLE.bit.MUX4 = 1;
	EPwmXbarRegs.TRIPOUTINV.bit.TRIP4 = 0;				//TRIP4
	EDIS;
/*******************************************************************************************/

	//EPWM2A is A-INV AuxUP Drv      EPWM2B is A-INV AuxDOWN Drv

/***********************************************************************************************/
	EALLOW;
	EPwm2Regs.TZFRC.bit.OST = TZ_ENABLE;

	EPwm2Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; // Count up-down
	EPwm2Regs.TBPRD = EPWM2_TIMER_TBPRD;       // Set timer period
	EPwm2Regs.TBCTL.bit.PHSEN = TB_DISABLE;    // enable phase loading
	EPwm2Regs.TBPHS.bit.TBPHS = 0x0001;       // Phase is 2
	EPwm2Regs.TBCTR = 0x0000;                  // Clear counter
	EPwm2Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   // Clock ratio to SYSCLKOUT
	EPwm2Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm2Regs.TBCTL.bit.PHSDIR = TB_UP;
	EPwm2Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_DISABLE;		//TB_SYNC_IN;
	EPwm2Regs.TBCTL.bit.PRDLD = TB_SHADOW;

	// Setup shadow register load on ZERO
	EPwm2Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;
	EPwm2Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
	EPwm2Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;
	EPwm2Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO_PRD;

	// Set Compare values
	EPwm2Regs.CMPA.bit.CMPA = EPWM1_MIN_CMPA;    // Set compare A value
	EPwm2Regs.CMPB.bit.CMPB = EPWM1_MIN_CMPB;              // Set Compare B value

	// Set actions
	EPwm2Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
	EPwm2Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
	EPwm2Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
	EPwm2Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
	EPwm2Regs.AQCTLA.bit.PRD = AQ_NO_ACTION;
	EPwm2Regs.AQCTLA.bit.ZRO = AQ_NO_ACTION;

	EPwm2Regs.AQCTLB.bit.CAU = AQ_NO_ACTION;        			//CNT = CMPA up   ->0
	EPwm2Regs.AQCTLB.bit.CAD = AQ_NO_ACTION;        				//CNT = CMPA down ->1
	EPwm2Regs.AQCTLB.bit.CBU = AQ_CLEAR;
	EPwm2Regs.AQCTLB.bit.CBD = AQ_SET;
	EPwm2Regs.AQCTLB.bit.PRD = AQ_NO_ACTION;
	EPwm2Regs.AQCTLB.bit.ZRO = AQ_NO_ACTION;

	EPwm2Regs.AQSFRC.bit.RLDCSF = 3;		        		//The active register load immediately
	EPwm2Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm2Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH

	EPwm2Regs.DBCTL.bit.IN_MODE = DBA_RED_DBB_FED;				//EPWMxA In is the source for rising-edge delayed signal.
														//EPWMxA In is the source for falling-edge delayed signal.
	EPwm2Regs.DBCTL.bit.DEDB_MODE = 0;
	EPwm2Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC;				//Active high complementary (AHC). EPWMxB is inverted.
	EPwm2Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE;			//Enable dead band time configuration
	EPwm2Regs.DBCTL.bit.OUTSWAP = 0;						//A pathͬʱΪEPWMABʱ
	EPwm2Regs.DBRED = EPWM1_DBRED;								//SYSCLK/EPWM2_DB = 60M/0.7M
	EPwm2Regs.DBFED = EPWM1_DBFED;								//SYSCLK/EPWM2_DB = 60M/0.7M

	EPwm2Regs.PCCTL.bit.CHPEN = CHP_DISABLE;						//Disable chopping function

	EPwm2Regs.TZSEL.bit.DCAEVT2 = TZ_ENABLE;		//Enable DCAEVT2 as a CBC trip source for EPWM1
	EPwm2Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;		//DCAH==High,trigger TZ
	EPwm2Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm2Regs.TZCTL.bit.TZB = TZ_FORCE_LO;
	EPwm2Regs.TZCLR.bit.CBCPULSE = 1;				//CTR = Zero or PRD pulse clears CBC trip latch
/*
	EPwm2Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN5;
	EPwm2Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
	EPwm2Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
	EPwm2Regs.DCAHTRIPSEL.bit.TRIPINPUT5 = 1;

	EPwmXbarRegs.TRIP5MUX0TO15CFG.bit.MUX8 = 1;		//CMP5P HIGH or LOW
	EPwmXbarRegs.TRIP5MUXENABLE.bit.MUX8 = 1;
	EPwmXbarRegs.TRIPOUTINV.bit.TRIP5 = 0;
*/
	EPwm2Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN4;
	EPwm2Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
	EPwm2Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
	EPwm2Regs.DCAHTRIPSEL.bit.TRIPINPUT4 = 1;

/*
	EPwmXbarRegs.TRIP4MUX0TO15CFG.bit.MUX4 = 1;			//CMP3P HIGH or Low
	EPwmXbarRegs.TRIP4MUXENABLE.bit.MUX4 = 1;
	EPwmXbarRegs.TRIPOUTINV.bit.TRIP4 = 0;				//TRIP4
*/
	EDIS;
/***********************************************************************************************

					//EPWM3 is FAN Drv

***********************************************************************************************/
	EALLOW;
	EPwm3Regs.TBPRD = EPWM3_TIMER_TBPRD;       		// Set timer period
	EPwm3Regs.TBPHS.bit.TBPHS = 0x0000;
	EPwm3Regs.TBCTR = 0;
	EPwm3Regs.TBCTL.bit.CTRMODE = TB_COUNT_DOWN;			//Up-Down mode
	EPwm3Regs.TBCTL.bit.PHSEN = TB_DISABLE;
	EPwm3Regs.TBCTL.bit.PRDLD = TB_SHADOW;					//Shadow mode
	EPwm3Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_DISABLE;  			//Synchronized while TBCNT=0
	EPwm3Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;     			//TBCLK = SYSCLK / (HSPCLKDIV * CLKDIV) = 100MHz/(1*1)=100MHz
	EPwm3Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm3Regs.TBCTL.bit.PHSDIR = TB_DOWN;

	EPwm3Regs.CMPA.bit.CMPA = EPWM3_MIN_CMPA;
	EPwm3Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;		      	//Shadow mode
	EPwm3Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;	    //Load on CTR = Zero or PRD

	EPwm3Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
	EPwm3Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
	EPwm3Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
	EPwm3Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
	EPwm3Regs.AQCTLA.bit.PRD = AQ_NO_ACTION;
	EPwm3Regs.AQCTLA.bit.ZRO = AQ_NO_ACTION;
	EPwm3Regs.AQCSFRC.bit.CSFA = FORCE_LOW;
	EPwm3Regs.AQCSFRC.bit.CSFB = FORCE_LOW;

	EPwm3Regs.AQSFRC.bit.RLDCSF = 3;		        		//The active register load immediately
	EPwm3Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE LOW
//	EPwm4Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM3B output  LOW

	EPwm3Regs.DBCTL.bit.OUT_MODE = DB_DISABLE;			//Disable dead band time configuration
	EPwm3Regs.DBCTL.bit.OUTSWAP = 0;

	EPwm3Regs.PCCTL.bit.CHPEN = CHP_DISABLE;
//	TrigRegs.SYNCSELECT.bit.EPWM3SYNCIN = 0;			//EPWM1SYNCOUT selected
	EDIS;
/***********************************************************************************************

				//EPWM4A is B-INV UP Drv      EPWM4B is B-INV DOWN Drv

***********************************************************************************************/
    EALLOW;
    SyncSocRegs.SYNCSELECT.bit.EPWM4SYNCIN = 0;		////EPWM1SYNCOUT selected
	
    EPwm4Regs.TZFRC.bit.OST = TZ_ENABLE;

    EPwm4Regs.TBPRD = EPWM4_TIMER_TBPRD;       		// Set timer period
	EPwm4Regs.TBPHS.bit.TBPHS = 0x0001;
	EPwm4Regs.TBCTR = 0x0000;

	EPwm4Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN;			//Up-Down mode
	EPwm4Regs.TBCTL.bit.PHSEN = TB_DISABLE;					//Sync ensable
	EPwm4Regs.TBCTL.bit.PRDLD = TB_SHADOW;					//Shadow mode
	EPwm4Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO;  			//Synchronized while TBCNT=0
	EPwm4Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;     			//TBCLK = SYSCLK / (HSPCLKDIV * CLKDIV) = 100MHz/(1*1)=100MHz
	EPwm4Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm4Regs.TBCTL.bit.PHSDIR = TB_UP;

	EPwm4Regs.CMPA.bit.CMPA = EPWM4_MIN_CMPA;
	EPwm4Regs.CMPB.bit.CMPB = EPWM4_MIN_CMPB;

	EPwm4Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;		      	//Shadow mode
	EPwm4Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;			    //Shadow mode
	EPwm4Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;	    //Load on CTR = Zero or PRD
	EPwm4Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO_PRD;	    //Load on CTR = Zero or PRD

	// Set actions
	EPwm4Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
	EPwm4Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
	EPwm4Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
	EPwm4Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
	EPwm4Regs.AQCTLA.bit.PRD = AQ_NO_ACTION;
	EPwm4Regs.AQCTLA.bit.ZRO = AQ_NO_ACTION;

	EPwm4Regs.AQCTLB.bit.CAU = AQ_NO_ACTION;        			//CNT = CMPA up   ->0
	EPwm4Regs.AQCTLB.bit.CAD = AQ_NO_ACTION;        				//CNT = CMPA down ->1
	EPwm4Regs.AQCTLB.bit.CBU = AQ_CLEAR;
	EPwm4Regs.AQCTLB.bit.CBD = AQ_SET;
	EPwm4Regs.AQCTLB.bit.PRD = AQ_NO_ACTION;
	EPwm4Regs.AQCTLB.bit.ZRO = AQ_NO_ACTION;

	EPwm4Regs.AQSFRC.bit.RLDCSF = 3;		        		//The active register load immediately
	EPwm4Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm4Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH

	EPwm4Regs.DBCTL.bit.IN_MODE = DBA_RED_DBB_FED;				//EPWMxA In is the source for rising-edge delayed signal.
														//EPWMxA In is the source for falling-edge delayed signal.
	EPwm4Regs.DBCTL.bit.DEDB_MODE = 0;
	EPwm4Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC;				//Active high complementary (AHC). EPWMxB is inverted.
	EPwm4Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE;			//Enable dead band time configuration
	EPwm4Regs.DBCTL.bit.OUTSWAP = 0;						//A pathͬʱΪEPWMABʱ
	EPwm4Regs.DBRED = EPWM4_DBRED;								//SYSCLK/EPWM2_DB = 60M/0.7M
	EPwm4Regs.DBFED = EPWM4_DBFED;								//SYSCLK/EPWM2_DB = 60M/0.7M

	EPwm4Regs.PCCTL.bit.CHPEN = CHP_DISABLE;						//Disable chopping function

	EPwm4Regs.TZSEL.bit.DCAEVT2 = TZ_ENABLE;		//Enable DCAEVT2 as a CBC trip source for EPWM1
	EPwm4Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;		//DCAH==High,trigger TZ
	EPwm4Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm4Regs.TZCTL.bit.TZB = TZ_FORCE_LO;
	EPwm4Regs.TZCLR.bit.CBCPULSE = 1;				//CTR = Zero or PRD pulse clears CBC trip latch

	EPwm4Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN4;
	EPwm4Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
	EPwm4Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
	EPwm4Regs.DCAHTRIPSEL.bit.TRIPINPUT4 = 1;

	EPwmXbarRegs.TRIP4MUX0TO15CFG.bit.MUX14 = 1;		//CMP8P HIGH or LOW
	EPwmXbarRegs.TRIP4MUXENABLE.bit.MUX14 = 1;
	EPwmXbarRegs.TRIPOUTINV.bit.TRIP4 = 0;
	EDIS;
/***********************************************************************/

		//EPWM5A is INV AuxUP Drv      EPWM5B is INV AuxDOWN Drv

/***********************************************************************/
	EALLOW;

	EPwm5Regs.TZFRC.bit.OST = TZ_ENABLE;

	EPwm5Regs.TBPRD = EPWM5_TIMER_TBPRD;       				// Set timer period
	EPwm5Regs.TBPHS.bit.TBPHS = 0x0001;
	EPwm5Regs.TBCTR = 0x0000;

   	EPwm5Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; 			// Count up and down
	EPwm5Regs.TBCTL.bit.PHSEN = TB_DISABLE;      		// Phase loading disabled		(Do not load the time-base counter (TBCTR) from the time-base phase register)
   	EPwm5Regs.TBCTL.bit.PRDLD = TB_SHADOW;
   	EPwm5Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_DISABLE;		//TB_SYNC_IN;
   	EPwm5Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   				// Clock ratio to SYSCLKOUT
   	EPwm5Regs.TBCTL.bit.CLKDIV = TB_DIV1;
   	EPwm5Regs.TBCTL.bit.PHSDIR = TB_UP;

   	EPwm5Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;				//SHDWAMODE is selected
   	EPwm5Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
   	EPwm5Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;
   	EPwm5Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO_PRD;

   	EPwm5Regs.CMPA.bit.CMPA= EPWM5_MIN_CMPA;
   	EPwm5Regs.CMPB.bit.CMPB= EPWM5_MIN_CMPB;

	// Set actions
   	EPwm5Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
   	EPwm5Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
   	EPwm5Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
   	EPwm5Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
   	EPwm5Regs.AQCTLA.bit.PRD = AQ_NO_ACTION;
   	EPwm5Regs.AQCTLA.bit.ZRO = AQ_NO_ACTION;

   	EPwm5Regs.AQCTLB.bit.CAU = AQ_NO_ACTION;        			//CNT = CMPA up   ->0
   	EPwm5Regs.AQCTLB.bit.CAD = AQ_NO_ACTION;        				//CNT = CMPA down ->1
   	EPwm5Regs.AQCTLB.bit.CBU = AQ_CLEAR;
   	EPwm5Regs.AQCTLB.bit.CBD = AQ_SET;
   	EPwm5Regs.AQCTLB.bit.PRD = AQ_NO_ACTION;
   	EPwm5Regs.AQCTLB.bit.ZRO = AQ_NO_ACTION;

   	EPwm5Regs.AQSFRC.bit.RLDCSF = 3;		        		//The active register load immediately
   	EPwm5Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
   	EPwm5Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH

   	EPwm5Regs.DBCTL.bit.IN_MODE = DBA_RED_DBB_FED;				//EPWMxA In is the source for rising-edge delayed signal.
														//EPWMxA In is the source for falling-edge delayed signal.
   	EPwm5Regs.DBCTL.bit.DEDB_MODE = 0;
   	EPwm5Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC;				//Active high complementary (AHC). EPWMxB is inverted.
   	EPwm5Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE;			//Enable dead band time configuration
   	EPwm5Regs.DBCTL.bit.OUTSWAP = 0;						//A pathͬʱΪEPWMABʱ
   	EPwm5Regs.DBRED = EPWM4_DBRED;								//SYSCLK/EPWM2_DB = 60M/0.7M
   	EPwm5Regs.DBFED = EPWM4_DBFED;								//SYSCLK/EPWM2_DB = 60M/0.7M

	EPwm5Regs.PCCTL.bit.CHPEN = CHP_DISABLE;			//Disable chopping function
	/*
	EPwm5Regs.TZSEL.bit.CBC2 = TZ_ENABLE;
//	EPwm5Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;
	EPwm5Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm5Regs.TZCTL.bit.TZB = TZ_FORCE_LO;
//	EPwm5Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN10;
//	EPwm5Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
//	EPwm5Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
*/

	EPwm5Regs.TZSEL.bit.DCAEVT2 = TZ_ENABLE;		//Enable DCAEVT2 as a CBC trip source for EPWM1
	EPwm5Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;		//DCAH==High,trigger TZ
	EPwm5Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm5Regs.TZCTL.bit.TZB = TZ_FORCE_LO;
	EPwm5Regs.TZCLR.bit.CBCPULSE = 1;				//CTR = Zero or PRD pulse clears CBC trip latch

	EPwm5Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN4;
	EPwm5Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
	EPwm5Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
	EPwm5Regs.DCAHTRIPSEL.bit.TRIPINPUT4 = 1;

/*	EPwmXbarRegs.TRIP7MUX0TO15CFG.bit.MUX14 = 1;		//CMP8P HIGH or LOW
	EPwmXbarRegs.TRIP7MUXENABLE.bit.MUX14 = 1;
	EPwmXbarRegs.TRIPOUTINV.bit.TRIP7 = 0;*/
	EDIS;

/***********************************************************************************************

				//EPWM6A Interrupt

***********************************************************************************************/
	EALLOW;
	EPwm6Regs.TBPRD = EPWM6_TIMER_TBPRD;       		// Set timer period
	EPwm6Regs.TBCTR = 0x0000;
	EPwm6Regs.TBPHS.bit.TBPHS = 0x0000;       			// Phase is 0
	// Setup TBCLK
	EPwm6Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; 	// Count up-down
	EPwm6Regs.TBCTL.bit.PHSEN = TB_DISABLE;    		// enable phase loading
	EPwm6Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   		// Clock ratio to SYSCLKOUT
	EPwm6Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm6Regs.TBCTL.bit.PHSDIR = TB_UP;
	EPwm6Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO;
	EPwm6Regs.TBCTL.bit.PRDLD = TB_SHADOW;

	EPwm6Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
	EPwm6Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
	EPwm6Regs.AQCTLB.bit.CBU = AQ_CLEAR;        			//CNT = CMPA up   ->0
	EPwm6Regs.AQCTLB.bit.CBD = AQ_SET;        				//CNT = CMPA down ->1

	EPwm6Regs.CMPA.bit.CMPA = 375;//EPWM7_MIN_CMPA;
	EPwm6Regs.CMPB.bit.CMPB = 375;//EPWM7_MIN_CMPA;
	EPwm6Regs.AQCSFRC.bit.CSFA = AQC_NO_ACTION;					//FORCE LOW
	EPwm6Regs.AQCSFRC.bit.CSFB = AQC_NO_ACTION;					//FORCE the EPWM3B output  LOW

	EPwm6Regs.AQSFRC.bit.RLDCSF = 3;
	EPwm6Regs.DBCTL.bit.OUT_MODE = DB_DISABLE;

	EPwm6Regs.ETSEL.bit.SOCAEN	= 1;	        // Disable SOC on A group
	EPwm6Regs.ETSEL.bit.SOCASEL	= ET_CTR_PRDZERO;	// Select SOC on up-count
	EPwm6Regs.ETPS.bit.SOCAPRD = 1;		        // Generate pulse on 1st event

	EDIS;


/***********************************************************************************************

				//EPWM7A is C-INV UP Drv      EPWM7B is C-INV DOWN Drv

***********************************************************************************************/
	EALLOW;
	SyncSocRegs.SYNCSELECT.bit.EPWM7SYNCIN = 0;		//EPWM1SYNCOUT selected

	EPwm7Regs.TZFRC.bit.OST = TZ_ENABLE;

	EPwm7Regs.TBPRD = EPWM7_TIMER_TBPRD;       		// Set timer period
	EPwm7Regs.TBPHS.bit.TBPHS = 0x0001;
	EPwm7Regs.TBCTR = 0x0000;

	EPwm7Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN;			//Up-Down mode
	EPwm7Regs.TBCTL.bit.PHSEN = TB_DISABLE;					//Sync ensable
	EPwm7Regs.TBCTL.bit.PRDLD = TB_SHADOW;					//Shadow mode
	EPwm7Regs.TBCTL.bit.SYNCOSEL = TB_CTR_ZERO;  			//Synchronized while TBCNT=0
	EPwm7Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;     			//TBCLK = SYSCLK / (HSPCLKDIV * CLKDIV) = 100MHz/(1*1)=100MHz
	EPwm7Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm7Regs.TBCTL.bit.PHSDIR = TB_UP;

	EPwm7Regs.CMPA.bit.CMPA = EPWM7_MIN_CMPA;
	EPwm7Regs.CMPB.bit.CMPB = EPWM7_MIN_CMPB;

	EPwm7Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;		      	//Shadow mode
	EPwm7Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;			    //Shadow mode
	EPwm7Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;	    //Load on CTR = Zero or PRD
	EPwm7Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO_PRD;	    //Load on CTR = Zero or PRD

	// Set actions
	EPwm7Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
	EPwm7Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
	EPwm7Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
	EPwm7Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
	EPwm7Regs.AQCTLA.bit.PRD = AQ_NO_ACTION;
	EPwm7Regs.AQCTLA.bit.ZRO = AQ_NO_ACTION;

	EPwm7Regs.AQCTLB.bit.CAU = AQ_NO_ACTION;        			//CNT = CMPA up   ->0
	EPwm7Regs.AQCTLB.bit.CAD = AQ_NO_ACTION;        				//CNT = CMPA down ->1
	EPwm7Regs.AQCTLB.bit.CBU = AQ_CLEAR;
	EPwm7Regs.AQCTLB.bit.CBD = AQ_SET;
	EPwm7Regs.AQCTLB.bit.PRD = AQ_NO_ACTION;
	EPwm7Regs.AQCTLB.bit.ZRO = AQ_NO_ACTION;

	EPwm7Regs.AQSFRC.bit.RLDCSF = 3;		        		//The active register load immediately
	EPwm7Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm7Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH

	EPwm7Regs.DBCTL.bit.IN_MODE = DBA_RED_DBB_FED;				//EPWMxA In is the source for rising-edge delayed signal.
														//EPWMxA In is the source for falling-edge delayed signal.
	EPwm7Regs.DBCTL.bit.DEDB_MODE = 0;
	EPwm7Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC;				//Active high complementary (AHC). EPWMxB is inverted.
	EPwm7Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE;			//Enable dead band time configuration
	EPwm7Regs.DBCTL.bit.OUTSWAP = 0;						//A pathͬʱΪEPWMABʱ
	EPwm7Regs.DBRED = EPWM7_DBRED;								//SYSCLK/EPWM2_DB = 60M/0.7M
	EPwm7Regs.DBFED = EPWM7_DBFED;								//SYSCLK/EPWM2_DB = 60M/0.7M

	EPwm7Regs.PCCTL.bit.CHPEN = CHP_DISABLE;						//Disable chopping function

	EPwm7Regs.TZSEL.bit.DCAEVT2 = TZ_ENABLE;		//Enable DCAEVT2 as a CBC trip source for EPWM1
	EPwm7Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;		//DCAH==High,trigger TZ
	EPwm7Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm7Regs.TZCTL.bit.TZB = TZ_FORCE_LO;
	EPwm7Regs.TZCLR.bit.CBCPULSE = 1;				//CTR = Zero or PRD pulse clears CBC trip latch

	EPwm7Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN4;
	EPwm7Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
	EPwm7Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
	EPwm7Regs.DCAHTRIPSEL.bit.TRIPINPUT4 = 1;

	EPwmXbarRegs.TRIP4MUX0TO15CFG.bit.MUX6 = 1;		//CMP4P HIGH or LOW
	EPwmXbarRegs.TRIP4MUXENABLE.bit.MUX6 = 1;
	EPwmXbarRegs.TRIPOUTINV.bit.TRIP4 = 0;
	EDIS;
/***********************************************************************/

		//EPWM8A is INV AuxUP Drv      EPWM8B is INV AuxDOWN Drv

/***********************************************************************/
	EALLOW;
	EPwm8Regs.TZFRC.bit.OST = TZ_ENABLE;

	EPwm8Regs.TBPRD = EPWM8_TIMER_TBPRD;       				// Set timer period
	EPwm8Regs.TBPHS.bit.TBPHS = 0x0001;							// Phase is 0
	EPwm8Regs.TBCTR = 0x0000;

	EPwm8Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN; 			// Count up and down
	EPwm8Regs.TBCTL.bit.PHSEN = TB_DISABLE;      		// Phase loading disabled		(Do not load the time-base counter (TBCTR) from the time-base phase register)
	EPwm8Regs.TBCTL.bit.PRDLD = TB_SHADOW;
	EPwm8Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_DISABLE;		//TB_SYNC_IN;
	EPwm8Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   				// Clock ratio to SYSCLKOUT
	EPwm8Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm8Regs.TBCTL.bit.PHSDIR = TB_UP;

	EPwm8Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;				//SHDWAMODE is selected
	EPwm8Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;
	EPwm8Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;
	EPwm8Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO_PRD;

	EPwm8Regs.CMPA.bit.CMPA= EPWM8_MIN_CMPA;
	EPwm8Regs.CMPB.bit.CMPB= EPWM8_MIN_CMPB;

	// Set actions
	EPwm8Regs.AQCTLA.bit.CAU = AQ_CLEAR;           			//CNT = CMPA up    ->0
	EPwm8Regs.AQCTLA.bit.CAD = AQ_SET;						//CNT = CMPB down ->1
	EPwm8Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
	EPwm8Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
	EPwm8Regs.AQCTLA.bit.PRD = AQ_NO_ACTION;
	EPwm8Regs.AQCTLA.bit.ZRO = AQ_NO_ACTION;

	EPwm8Regs.AQCTLB.bit.CAU = AQ_NO_ACTION;        			//CNT = CMPA up   ->0
	EPwm8Regs.AQCTLB.bit.CAD = AQ_NO_ACTION;        				//CNT = CMPA down ->1
	EPwm8Regs.AQCTLB.bit.CBU = AQ_CLEAR;
	EPwm8Regs.AQCTLB.bit.CBD = AQ_SET;
	EPwm8Regs.AQCTLB.bit.PRD = AQ_NO_ACTION;
	EPwm8Regs.AQCTLB.bit.ZRO = AQ_NO_ACTION;

	EPwm8Regs.AQSFRC.bit.RLDCSF = 3;		        		//The active register load immediately
	EPwm8Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm8Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH

	EPwm8Regs.DBCTL.bit.IN_MODE = DBA_RED_DBB_FED;				//EPWMxA In is the source for rising-edge delayed signal.
														//EPWMxA In is the source for falling-edge delayed signal.
	EPwm8Regs.DBCTL.bit.DEDB_MODE = 0;
	EPwm8Regs.DBCTL.bit.POLSEL = DB_ACTV_HIC;				//Active high complementary (AHC). EPWMxB is inverted.
	EPwm8Regs.DBCTL.bit.OUT_MODE = DB_FULL_ENABLE;			//Enable dead band time configuration
	EPwm8Regs.DBCTL.bit.OUTSWAP = 0;						//A pathͬʱΪEPWMABʱ
	EPwm8Regs.DBRED = EPWM7_DBRED;								//SYSCLK/EPWM2_DB = 60M/0.7M
	EPwm8Regs.DBFED = EPWM7_DBFED;								//SYSCLK/EPWM2_DB = 60M/0.7M

	EPwm8Regs.PCCTL.bit.CHPEN = CHP_DISABLE;			//Disable chopping function
	/*
	EPwm8Regs.TZSEL.bit.CBC1 = TZ_ENABLE;
//	EPwm8Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;
	EPwm8Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm8Regs.TZCTL.bit.TZB= TZ_FORCE_LO;
//	EPwm8Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN10;
//	EPwm8Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
//	EPwm8Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;

//	EPwmXbarRegs.TRIP10MUX0TO15CFG.bit.Mux12 = 0;
//	EPwmXbarRegs.TRIP10MUXENABLE.bit.Mux12 = 1;
//	EPwmXbarRegs.TRIPOUTINV.bit.OUT5 = 0;
*/
	EPwm8Regs.TZSEL.bit.DCAEVT2 = TZ_ENABLE;		//Enable DCAEVT2 as a CBC trip source for EPWM1
	EPwm8Regs.TZDCSEL.bit.DCAEVT2 = TZ_DCAH_HI;		//DCAH==High,trigger TZ
	EPwm8Regs.TZCTL.bit.TZA = TZ_FORCE_LO;
	EPwm8Regs.TZCTL.bit.TZB = TZ_FORCE_LO;
	EPwm8Regs.TZCLR.bit.CBCPULSE = 1;				//CTR = Zero or PRD pulse clears CBC trip latch

	EPwm8Regs.DCTRIPSEL.bit.DCAHCOMPSEL = DC_TRIPIN4;
	EPwm8Regs.DCACTL.bit.EVT2SRCSEL = DC_EVT2;
	EPwm8Regs.DCACTL.bit.EVT2FRCSYNCSEL = DC_EVT_ASYNC;
	EPwm8Regs.DCAHTRIPSEL.bit.TRIPINPUT4 = 1;

/*	EPwmXbarRegs.TRIP9MUX0TO15CFG.bit.MUX6 = 1;		//CMP4P HIGH or LOW
	EPwmXbarRegs.TRIP9MUXENABLE.bit.MUX6 = 1;
	EPwmXbarRegs.TRIPOUTINV.bit.TRIP9 = 0;*/
	EDIS;


/***************************************************************************/

	//EPWM9 ADC Source

/***************************************************************************/
	EALLOW;
	// Assumes ePWM clock is already enabled
	EPwm9Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   // Clock ratio to SYSCLKOUT
	EPwm9Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm9Regs.ETSEL.bit.SOCAEN	= 0;	        // Disable SOC on A group
	EPwm9Regs.ETSEL.bit.SOCASEL	= ET_CTR_PRD;	        // Select SOC on up-count
	EPwm9Regs.ETPS.bit.SOCAPRD = 1;		        // Generate pulse on 1st event
	EPwm9Regs.CMPA.bit.CMPA = EPWM9_MIN_CMPA;          // Set compare A value to 2048 counts
	EPwm9Regs.TBPRD = EPWM9_TIMER_TBPRD;			        // Set period to 4096 counts
	EPwm9Regs.TBCTL.bit.CTRMODE = TB_COUNT_UP;            // UP counter
	EDIS;

/********************************************************************************/

   					//EPWM10A is Carrier-Wave Sync

/*********************************************************************************/
	EALLOW;
	SyncSocRegs.SYNCSELECT.bit.EPWM10SYNCIN = 0;//2;//	  	//010: EPPW7SYNCOUT selected
//	EPwm10Regs.TZCTL.bit.TZB = TZ_FORCE_LO;					// Forced Low (EPWM10A = Low state)	
//	EPwm10Regs.TZFRC.bit.OST = TZ_ENABLE;					// Forces a one-shot trip event and sets the OSTFLG bit	

	EPwm10Regs.TBPRD = EPWM10_TIMER_TBPRD;       				// Set timer period:1K--1ms
	EPwm10Regs.CMPA.bit.CMPA= EPWM10_MIN_CMPA;
	EPwm10Regs.TBPHS.bit.TBPHS = 0x0000;							// Phase is 0
	EPwm10Regs.TBCTR = 0x0000;
	EPwm10Regs.TBCTL.bit.PHSDIR = TB_UP;
	EPwm10Regs.TBCTL.bit.CTRMODE = TB_COUNT_UP; 			// Count up
	EPwm10Regs.TBCTL.bit.PHSEN = TB_DISABLE;					//TB_ENABLE;					//Sync ensable	
	EPwm10Regs.TBCTL.bit.PRDLD = TB_SHADOW;
	EPwm10Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_DISABLE;		//TB_SYNC_DISABLE;		//TB_CTR_ZERO;  			//Synchronized while TBCNT=0
	EPwm10Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   				// Clock ratio to SYSCLKOUT
	EPwm10Regs.TBCTL.bit.CLKDIV = TB_DIV1;
	EPwm10Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;				//SHDWAMODE is selected
	EPwm10Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;
	EPwm10Regs.AQCTLA.bit.CAU = AQ_SET;						//AQ_CLEAR;		//AQ_NO_ACTION;           		// CNT = CMP up   ->1(force EPWMxA output high.)
	EPwm10Regs.AQCTLA.bit.CAD = AQ_CLEAR;					//AQ_SET;		//AQ_NO_ACTION;         		// CNT = CMP down ->0(force EPWMxA output low)
	EPwm10Regs.AQCTLA.bit.CBU = AQ_NO_ACTION;
	EPwm10Regs.AQCTLA.bit.CBD = AQ_NO_ACTION;
	EPwm10Regs.AQCTLA.bit.PRD = AQ_CLEAR;					//AQ_SET;
	EPwm10Regs.AQCTLA.bit.ZRO = AQ_CLEAR;					//AQ_SET;
	EPwm10Regs.AQSFRC.bit.RLDCSF = 3;		        	// the active register load immediately
	EPwm10Regs.AQCSFRC.bit.CSFA = AQC_NO_ACTION;		//FORCE_LOW;	
	EPwm10Regs.DBCTL.bit.OUT_MODE = DB_DISABLE;	//Dead-band delay DISABLE
//	Dead-band generation is bypassed
	EPwm10Regs.DBCTL.bit.POLSEL = DB_ACTV_HI;				//Active high  mode
	EPwm10Regs.DBRED = EPWM10_DBRED;
	EPwm10Regs.DBFED = EPWM10_DBFED;
	EPwm10Regs.DBCTL.bit.OUTSWAP = 0;

	EPwm10Regs.PCCTL.bit.CHPEN = CHP_DISABLE;
	EDIS;


/**********************************************************************************/

   					//EPWM11A is LBS Sync

/***********************************************************************************/
	EALLOW;

//	EPwm11Regs.TZCTL.bit.TZA = TZ_FORCE_LO;				// Forced high (EPWM11A = low state)
//	EPwm11Regs.TZCTL.bit.TZB = TZ_FORCE_LO;				// Forced high (EPWM11B = low state)
	EPwm11Regs.TZFRC.bit.OST = TZ_ENABLE;				// Forces a one-shot trip event ;
//	EPwm11Regs.TZCLR.bit.OST = TZ_ENABLE;

//	EPwm11Regs.CMPB.bit.CMPB = 9000;								
	EPwm11Regs.TBPHS.bit.TBPHS = 0x0000;							// Phase is 0	// Set Phase register to zero
	EPwm11Regs.TBCTR = 0x0000;
	EPwm11Regs.TBCTL.bit.PRDLD = TB_IMMEDIATE;				//TB_SHADOW;
	EPwm11Regs.TBCTL.bit.PHSDIR = TB_UP;
	EPwm11Regs.TBCTL.bit.CTRMODE = TB_COUNT_UP; 			// Count up and down
	EPwm11Regs.TBCTL.bit.PHSEN = TB_DISABLE;      				// ˴Ҫӻ ͬӻͬ Phase loading disabled		(Do not load the time-base counter (TBCTR) from the time-base phase register)

	EPwm11Regs.TBCTL.bit.SYNCOSEL = TB_SYNC_DISABLE;
	EPwm11Regs.TBCTL.bit.HSPCLKDIV = TB_DIV5;   				// Clock ratio to SYSCLKOUT	10
	EPwm11Regs.TBCTL.bit.CLKDIV = TB_DIV5;					//32
	EPwm11Regs.TBPRD = EPWM11_TIMER_TBPRD;       				// Set timer period:96ms	 30000*32*10*16.7ns=96ms So 20ms is 3750
	EPwm11Regs.CMPA.bit.CMPA = 20000;				//2250;		// TBPRD,[3906*2,2232*2]=[40Hz,70Hz]
	EPwm11Regs.CMPCTL.bit.SHDWAMODE = CC_SHADOW;				//SHDWAMODE is selected
	EPwm11Regs.CMPCTL.bit.SHDWBMODE = CC_SHADOW;				//SHDWBMODE is selected
	EPwm11Regs.CMPCTL.bit.LOADAMODE = CC_CTR_ZERO_PRD;			// load on CTR = Zero or PRD
	EPwm11Regs.CMPCTL.bit.LOADBMODE = CC_CTR_ZERO_PRD;			// load on CTR = Zero or PRD
	EPwm11Regs.AQCTLA.bit.CAU = AQ_SET;				//AQ_CLEAR;           		// CNT = CMP up   ->1(force EPWMxA output high.)
	EPwm11Regs.AQCTLA.bit.CAD = AQ_CLEAR;				//AQ_SET;         				// CNT = CMP down ->0(force EPWMxA output low)
	EPwm11Regs.AQCTLB.bit.CBU = AQ_NO_ACTION;				//AQ_CLEAR;           		// CNT = CMP up   ->1(force EPWMxA output high.)
	EPwm11Regs.AQCTLB.bit.CBD = AQ_NO_ACTION;				//AQ_SET;         		// CNT = CMP down ->0(force EPWMxA output low)
	EPwm11Regs.AQCTLA.bit.PRD = AQ_CLEAR;					//AQ_SET;
//	EPwm11Regs.AQCTLB.bit.PRD = AQ_SET;			//AQ_CLEAR;
	EPwm11Regs.AQCTLA.bit.ZRO = AQ_CLEAR;			//AQ_SET;					//AQC_NO_ACTION;
	EPwm11Regs.AQSFRC.bit.RLDCSF = 3;		        	// the active register load immediately
	EPwm11Regs.AQCSFRC.bit.CSFA = AQC_NO_ACTION;		// Software forcing disabled, i.e., has no effect
	EPwm11Regs.AQCSFRC.bit.CSFB = AQC_NO_ACTION;		// Software forcing disabled, i.e., has no effect
	EPwm11Regs.DBCTL.bit.OUT_MODE = DB_DISABLE;	//Dead-band delay DISABLE
	EPwm11Regs.DBCTL.bit.POLSEL = DB_ACTV_LOC;		//DB_ACTV_HI;
	EPwm11Regs.DBRED = EPWM11_DBRED;
	EPwm11Regs.DBFED = EPWM11_DBFED;
//	Dead-band generation is bypassed
	EPwm11Regs.DBCTL.bit.OUTSWAP = 0;

	EPwm11Regs.PCCTL.bit.CHPEN = CHP_DISABLE;
	EPwm11Regs.TZCLR.bit.OST = TZ_ENABLE;
	EDIS;
//	EPwm11Regs.TBPRD = EPWM11_TIMER_TBPRD;
	/***************************************************************************/

		//EPWM12 Com Int Source

	/***************************************************************************/
	EALLOW;
	// Assumes ePWM clock is already enabled
	EPwm12Regs.TBCTL.bit.HSPCLKDIV = TB_DIV1;   // Clock ratio to SYSCLKOUT
	EPwm12Regs.TBCTL.bit.CLKDIV = TB_DIV1;

	EPwm12Regs.CMPA.bit.CMPA = EPWM2_MIN_CMPA;          // Set compare A value to 2048 counts
	EPwm12Regs.TBPRD = EPWM12_TIMER_TBPRD;			        // Set period to 4096 counts
	EPwm12Regs.TBCTL.bit.CTRMODE = TB_COUNT_UPDOWN;            // UP counter
	EPwm12Regs.ETSEL.bit.SOCAEN	= 0;	        // Disable SOC on A group
	EPwm12Regs.ETSEL.bit.SOCASEL	= ET_CTR_PRD;	        // Select SOC on up-count
	EPwm12Regs.ETPS.bit.SOCAPRD = 1;		        // Generate pulse on 1st event
	EPwm12Regs.ETSEL.bit.INTSEL = ET_CTR_PRD;  //ET_CTR_PRDZERO;     			// Select INT on Zero or PRD event
//	EPwm12Regs.ETCLR.bit.INT=1;						// жϱ־
	EPwm12Regs.ETSEL.bit.INTEN = 0;                	// Enable PWM ZERO INT
	EPwm12Regs.ETPS.bit.INTPRD = ET_1ST;		//PWM INT occurs every  event
	EDIS;

	EALLOW;
	EPwm1Regs.TBCTR = 0x0000;
	EPwm2Regs.TBCTR = 0x0000;
	EPwm3Regs.TBCTR = 0x0000;
	EPwm4Regs.TBCTR = 0x0000;
	EPwm5Regs.TBCTR = 0x0000;
	EPwm6Regs.TBCTR = 0x0000;
	EPwm7Regs.TBCTR = 0x0000;
	EPwm8Regs.TBCTR = 0x0000;
	EPwm9Regs.TBCTR = 0x0000;
	EPwm10Regs.TBCTR = 0x0000;
	EPwm11Regs.TBCTR = 0x0000;
	EPwm12Regs.TBCTR = 0x0000;
	EDIS;

	EALLOW;
   	CpuSysRegs.PCLKCR0.bit.TBCLKSYNC =1;
   	EDIS;
}

//ʹPWM1ж
inline	void	Class_PWMDrv::Drv_PWM12InterruptEnable(void)
{
	EALLOW;
	EPwm12Regs.ETSEL.bit.INTSEL = ET_CTR_PRD;     			// Select INT on CNTR=PERIOD event
	EPwm12Regs.ETCLR.bit.INT=1;						// жϱ־
	EPwm12Regs.ETSEL.bit.INTEN = 1;                	// Enable PWM ZERO INT
	EDIS;
}


#pragma CODE_SECTION(".Epwm1Funcs")

inline void 	Class_PWMDrv::Drv_LLCPWM(INT16 i16_LLCPwmEnable,INT16 i16_PRD,INT16 i16_CMPA,INT16 i16_CMPB)
{
/*
//	if(objDischarger.m_st_FlagDischg.bDischg != 0)
	if(i16_LLCPwmEnable == 1)
	{
		EPwm7Regs.TBPRD = i16_PRD;
		EPwm7Regs.CMPA.half.CMPA = i16_CMPA;
		EPwm7Regs.CMPB = i16_CMPB;

		EPwm7Regs.AQCSFRC.bit.CSFA = AQC_NO_ACTION;
		EPwm7Regs.AQCSFRC.bit.CSFB = AQC_NO_ACTION;
	}
	else
	{
		EPwm7Regs.TBPRD = LLCPRD_UP_LMT;
		EPwm7Regs.CMPA.half.CMPA = LLCCMPA_LMT_VALUE_DOWN;
		EPwm7Regs.CMPB = LLCCMPB_LMT_VALUE_DOWN;
		
		EPwm7Regs.AQCSFRC.bit.CSFA = FORCE_LOW;
		EPwm7Regs.AQCSFRC.bit.CSFB = FORCE_LOW;
	}
*/
}

#pragma CODE_SECTION(".Epwm1Funcs")
inline void 	Class_PWMDrv::Drv_CHGPWM(INT16 i16_ChgPwmEnable,INT16 i16_CMPA,INT16 i16_CMPB)
{
/*
	if(i16_ChgPwmEnable != 0)
	{
		EPwm5Regs.CMPA.half.CMPA = i16_CMPA;
		EPwm5Regs.CMPB = i16_CMPB;

		EPwm5Regs.AQCSFRC.bit.CSFA = AQC_NO_ACTION;
		EPwm5Regs.AQCSFRC.bit.CSFB = AQC_NO_ACTION;
	}
	else
	{
		EPwm5Regs.CMPA.half.CMPA = 748;
		EPwm5Regs.CMPB = 2;
		
		EPwm5Regs.AQCSFRC.bit.CSFA = FORCE_LOW;
		EPwm5Regs.AQCSFRC.bit.CSFB = FORCE_LOW;
	}

*/
}

#pragma CODE_SECTION(".Epwm1Funcs")
inline void 	Class_PWMDrv::Drv_BoostPWM(INT16 i16_BoostPwmEnable,INT16 i16_DCDCBoostPwmEnable,INT16 i16_PFCCMPA,INT16 i16_PFCCMPB,INT16 i16_DCDCCMPA)
{
/*
	if(i16_BoostPwmEnable != 0)
	{
		EPwm6Regs.CMPA.half.CMPA = i16_PFCCMPA;
		EPwm6Regs.CMPB = i16_PFCCMPB;

		EPwm6Regs.AQCSFRC.bit.CSFA = AQC_NO_ACTION;
		EPwm6Regs.AQCSFRC.bit.CSFB = AQC_NO_ACTION;
	}
	else if(i16_DCDCBoostPwmEnable != 0)
	{
		EPwm6Regs.CMPA.half.CMPA = i16_DCDCCMPA;
		EPwm6Regs.CMPB = CMPR_LMT_VALUE_DOWN;
		
		EPwm6Regs.AQCSFRC.bit.CSFA = AQC_NO_ACTION;
		EPwm6Regs.AQCSFRC.bit.CSFB = FORCE_LOW;
	}
	else
	{
		EPwm6Regs.CMPA.half.CMPA = CMPR_LMT_VALUE_DOWN;
		EPwm6Regs.CMPB = CMPR_LMT_VALUE_DOWN;
		
		EPwm6Regs.AQCSFRC.bit.CSFA = FORCE_LOW;
		EPwm6Regs.AQCSFRC.bit.CSFB = FORCE_LOW;
	
	}
*/
}



/************************************************************************************
ƣ  Drv_RecDischgPWMInActive()
	PWMЧ
************************************************************************************/
#pragma CODE_SECTION(".Epwm1Funcs")

void 	Class_PWMDrv::Drv_InvPWMActive(void)
{
	EALLOW;
	EPwm1Regs.TZCLR.bit.OST = TZ_ENABLE;
	EPwm2Regs.TZCLR.bit.OST = TZ_ENABLE;
	EPwm4Regs.TZCLR.bit.OST = TZ_ENABLE;
	EPwm5Regs.TZCLR.bit.OST = TZ_ENABLE;
	EPwm7Regs.TZCLR.bit.OST = TZ_ENABLE;
	EPwm8Regs.TZCLR.bit.OST = TZ_ENABLE;
	EDIS;
}

/************************************************************************************
ƣ  Drv_RecDischgPWMInActive()
PWM
************************************************************************************/
#pragma CODE_SECTION(".Epwm1Funcs")

void 	Class_PWMDrv::Drv_InvPWMInActive(void)
{
	EALLOW;
	EPwm1Regs.TZFRC.bit.OST = TZ_ENABLE;							// Forces a one-shot trip event and sets the OSTFLG bit
	EPwm2Regs.TZFRC.bit.OST = TZ_ENABLE;							// Forces a one-shot trip event and sets the OSTFLG bit
	EPwm4Regs.TZFRC.bit.OST = TZ_ENABLE;
	EPwm5Regs.TZFRC.bit.OST = TZ_ENABLE;
	EPwm7Regs.TZFRC.bit.OST = TZ_ENABLE;
	EPwm8Regs.TZFRC.bit.OST = TZ_ENABLE;

	EPwm1Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm1Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH
	EPwm2Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm2Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH
	EPwm4Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm4Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH
	EPwm5Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm5Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH
	EPwm7Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm7Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH
	EPwm8Regs.AQCSFRC.bit.CSFA = FORCE_LOW;					//FORCE the EPWM2A output  LOW
	EPwm8Regs.AQCSFRC.bit.CSFB = FORCE_HIGH;				//FORCE the EPWM2B output  HIGH
	EDIS;
}

//============================================================
// End of file.
//============================================================
